/*
 * inflash.h
 *
 *  Created on: 2024624
 *      Author: psx
 */

#ifndef APP_INC_INFLASH_H_
#define APP_INC_INFLASH_H_

#include "debug.h"

#pragma pack(push,1)

typedef struct _uint8_config_info{
    uint8_t start_Flag[2];              /* ʼ־  */
    uint8_t address[7];                 /* ַ */
    uint8_t end_Flag;                   /* ־ */
    uint8_t Access_Node_Type[2];        /* ڵ  */
    uint8_t Communication_Methods[2];   /* ͨŷʽ  */
    uint8_t bat485_Baud[4];             /* ڲ,Ϊ0bms֧ͨ */
    uint8_t gw485_Baud[4];              /* ڲ */
    uint8_t ConstantCurrentV[2];        /* ڸ(ѹ / 100),СConstantVoltageV * 100ѹк */
    uint8_t ConstantVoltageV[2];        /* ڸ(ѹ / 100)ҵFloatI * 100кѹ */
    uint8_t FloatI[2];                  /* ڸ(ѹ / 100)ҵFloatI * 100и */
    uint8_t startSolarOpenCircuitV[2];  /* ڸ(ѹ / 100)ʼ */
}uint8_config_info;


typedef struct _config_info{
    uint8_t  start_Flag[2];         /* ʼ־  */
    uint8_t  address[7];            /* ַ */
    uint8_t  end_Flag;              /* ־ */
    uint16_t Access_Node_Type;      /* ڵ  */
    uint16_t Communication_Methods; /* ͨŷʽ  */
    uint32_t bat485_Baud;           /* ڲ */
    uint32_t gw485_Baud;            /* ڲ */
    uint16_t ConstantCurrentV;      /* ڸ(ѹ / 100),СConstantVoltageV / 100ѹк */
    uint16_t ConstantVoltageV;      /* ڸ(ѹ / 100)ҵFloatI / 100кѹ */
    uint16_t FloatI;                /* ڸ(ѹ / 100)ҵFloatI / 100и */
    uint16_t startSolarOpenCircuitV;/* ڸ(ѹ / 100)ʼ */
}config_info;
#define CONFIG_INFO_SIZE    (sizeof(config_info))
#pragma pack(pop)

/* ڵ */
typedef enum
{
   POWERBOX = 1,            /* Դ */
   MICROMETEOROLOGY = 2,    /* ΢ */
}SL_ACCESSNODETYPE;

/* ͨŷʽ */
typedef enum
{
    RS485 = 1,
    RJ45 = 2,
}SL_COMMUNICATIONMETHODS;

extern config_info g_slConfigInfo;

#define FLASH_SAVE_ADDR_BEGIN   (0x00)
#define FLASH_SAVE_ADDR_END     (0x00 + CONFIG_INFO_SIZE)

void save_config_info(config_info save_config_info);
uint8_t read_config_info(void);


#endif /* APP_INC_INFLASH_H_ */
