/*
 * tim.c
 *
 *  Created on: 2024622
 *      Author: psx
 */

#include "tim.h"
#include "timeSliceOffset.h"
#include "pwm.h"

/* ʱ׼Ϊ1ms1msлһ */
#define delayms 1

/* ʱʱ */
#define delays 2

uint8_t run_Broadcast = 1;

void TIM3_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

void TIM3_Init(void)
{
    /* Ƶϵ */
    uint16_t psc = (SystemCoreClock / 10000) - 1;
    /* Ƶϵ */
    uint16_t arr = delayms * 10 - 1;

    TIM3_Int_Init(arr, psc);
}

void TIM3_Int_Init(uint16_t arr, uint16_t psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_PB1PeriphClockCmd(RCC_PB1Periph_TIM3, ENABLE); //ʹTIM3ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;   //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler = psc; //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //TIMģʽϼģʽ
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ

    TIM_ITConfig(TIM3, TIM_IT_Update, ENABLE ); //ʹTIM3жϣж

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;           //TIM3ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0; //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;        //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;           //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure); //ʼNVIC

    TIM_Cmd(TIM3, ENABLE); //TIM3ʹ
}

void TIM3_IRQHandler(void)
{
//    static float duty_ratio = 0;
//    static int flag = 1;
//    static int flag1 = 0;
    if (TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET) { //TIM3жǷ
        TIM_ClearITPendingBit(TIM3, TIM_IT_Update);    //TIM3жϹλ
        TimeSliceOffset_Produce();
//        flag1++;
//        if (flag1 == 20) {
//            if (flag) {
//                duty_ratio += 0.005;
//                if (duty_ratio > 1) {
//                    flag = !flag;
//                }
//            } else {
//                duty_ratio -= 0.005;
//                if (duty_ratio < 0) {
//                    flag = !flag;
//                }
//            }
//            flag1 = 0;
//            Set_duty_ratio(duty_ratio);
//            printf(" TIM3_IRQHandler \n");
//        }
    }
}

void TIM2_Init(void)
{
    /* Ƶϵ */
    uint16_t psc = (SystemCoreClock / 1000) - 1;
    /* ֵ */
    uint16_t arr = delays * 1000 - 1;

    TIM2_Int_Init(arr, psc);
}

void TIM2_Int_Init(uint16_t arr, uint16_t psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_PB1PeriphClockCmd(RCC_PB1Periph_TIM2, ENABLE); //ʹTIM2ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;   //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler = psc; //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //TIMģʽϼģʽ
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ

    TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE); //ʹTIM2жϣж

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;           //TIM2ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1; //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;        //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;           //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure); //ʼNVIC

    TIM_Cmd(TIM2, ENABLE); //TIM2ʹ
}

void TIM2_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) {    //TIM2жǷ
        TIM_ClearITPendingBit(TIM2, TIM_IT_Update);         //TIM2жϹλ
        TIM_Cmd(TIM2, DISABLE);                         //TIM2ֹ
        TIM_ITConfig(TIM2, TIM_IT_Update, DISABLE);         //ֹTIM2ж
        printf("in time it \n");
        run_Broadcast = 1;
    }
}
